package Alnpack;

my $INIT = ' ' x 500;

BEGIN
{
	$ENV{ALNPACK} = (defined($ENV{LYNX}) ) ? "$ENV{LYNX}/alnpack-2.1" : "/home/gouzy/misc/alnpack-2.1";
	$ENV{INLINE_CPP_CONFIG} = "$ENV{ALNPACK}/_Inline";
	mkdir $ENV{INLINE_CPP_CONFIG} unless -d $ENV{INLINE_CPP_CONFIG};
}

no strict "subs";

use Inline ( CPP => Config => INC => "-I$ENV{ALNPACK}/src/libswaligner/ -I$ENV{ALNPACK}/src/libbio/ -I$ENV{ALNPACK}/src/libutil ", LIBS => "-L$ENV{ALNPACK}/src/lib -lswaligner -lbio -lutil", DIRECTORY => $ENV{INLINE_CPP_CONFIG});

use Inline CPP => 'DATA';

sub Aaln5
{
my($gi,$gx,$q,$q_seq,$s,$s_seq)=@_;

	my $aaln = $INIT; # il vaut mieux allouer avant sinon  si c'est fait dans le C++ le comportement est instable
	aaln5($gi,$gx,$q,$q_seq,$s,$s_seq,$aaln);
	$aaln =~ s/\s*$//;
	chop($aaln); # il y a un caract a la con (sans doute \0)
	return "$aaln <";
}

1;

#  Jerome.Gouzy@toulouse.inra.fr: modified from aaln5.cpp 

__DATA__
__CPP__

/***************************************************************************
                          main.cpp  -  description
                             -------------------
    begin                : Fri Jan 17 17:59:14 UTC 2003
    copyright            : (C) 2003 by Oleksiy Kohany
    email                : kohany@girinst.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <string.h>
#include "PairwiseAlignment.h"
#include "MonardoSWAligner.h"

using namespace std;
using namespace bio;

void aaln5(int iGI,int iGX,char *str_th,char *str_ts,char *str_bh,char *str_bs,char *strout)
{
   string th(str_th);
   string ts(str_ts);
   string bh(str_bh);
   string bs(str_bs);

   auto_ptr<SWAligner> pAligner;
   pAligner.reset(new MonardoSWAligner());
   if ( iGI != 0 ) {
	   pAligner->setGapIniPenalty(iGI);
   }
   if ( iGX != 0 ) {
   		pAligner->setGapExtPenalty(iGX);
	}

   NamedSubSequence top(th,ts);
   NamedSubSequence bot(bh,bs);

   // en principe le constructeur de top/bot aurait du s'en charger mais c'est necessaire
   top=ts;
   bot=bs;

   PairwiseAlignment aln(top,bot);
   pAligner->align(aln);
   PairwiseAlignmentStats stat = aln.getStat();
   top = aln.getTop();
   bot = aln.getBot();

   sprintf(strout,"%s %d %d %s %d %d %c %.4f %.4f %d",(const char *)top.getName().c_str(),(int)top.getFragments().front().getBeg() + 1,(int)top.getFragments().front().getEnd()
                                                     ,(const char *)bot.getName().c_str(),(int)bot.getFragments().front().getBeg() + 1,(int)bot.getFragments().front().getEnd()
													 ,(char)((top.isDirect() ^ bot.isDirect()) ? 'c' : 'd'),(float)stat.getSim(),(float)stat.getTrs(),(int)aln.getScore());
}

