#
# $Id: Fasta.pm 220 2013-12-20 14:48:08Z gouzy $
#

package SequenceSet::Fasta;

use SequenceSet;
use base qw( SequenceSet );

use General;
use GeneralBioinfo;
use Carp;

# Copyright INRA
# Jerome.Gouzy@toulouse.inra.fr

BEGIN
{
    our $VERSION = do {my @r = (q$Rev: 220 $ =~ /\d+/g); $r[0]};
}

=head2 procedure _Init

 Title        : _Init
 Function     : Constructor, initialize the object, do not use directly, use New method instead

=cut

sub _Init
{
	my ($self,%h_param) = @_;

	
	Carp::croak("Obsolete: utiliser SequenceSet::Hash\n");
}

=head2 procedure Load

 Title        : Load
 Usage        : $o_seqds->Load;

	pour le moment, ne charge que les longueurs

=cut

sub Load 
{
	my ($self,%h_param) = @_;

	my $what = (defined($h_param{what}) ) ? $h_param{what} : 'all';
	my $filein = $self->_FastOneGet('_infile');
	if ( $what eq 'noseq' && defined($h_param{verbose}) && $h_param{verbose} )
	{
		print STDERR "Sequences not loaded for dataset >$filein<\n";
		return 0;
	}
	my $f_inf = &GetStreamIn($filein);
	my ($cpt_in,$cpt_out)=(0,0);
	my $seq=undef;
	my $id=undef;
	my $type = $self->_FastOneGet('_type');
	my $mode = 2; # len+seq ( $what eq 'all')
	$mode = 1  if ( $what eq 'seq' ); # seq only
	$mode = -2 if ( $what eq 'len' ); # len only
	while (my $l = <$f_inf>)
	{	
		chomp($l);
		if ( $l =~ /^>(\S+)/ )
		{
			if ( defined($seq) ) 
			{
				&CleanSeq(\$seq,$type);
				$self->SetLen($id,length($seq)) if ( abs($mode) == 2 );
				$self->SetSeq($id,$seq)         if ( $mode > 0 );
				$cpt++;
			}
			$id = $1;
			$seq = '';
		}
		else
		{
			$seq .= $l;
		}
	}
	if ( defined($seq) ) 
	{
		&CleanSeq(\$seq,$type);
		$self->SetLen($id,length($seq)) if ( abs($mode) == 2 );
		$self->SetSeq($id,$seq)         if ( $mode > 0 );
		$cpt++;
	}
	$f_inf->close;
	$self->_Set('count',$cpt);
	if ( defined($h_param{verbose}) && $h_param{verbose} )
	{
		print STDERR "Seq in: $cpt\n";
	}
	return $cpt;
}




1;



