#
# $Id$
#

package SequenceSet::RMAP;

use SequenceSet;
use base qw( SequenceSet );

use General;
use GeneralBioinfo;
use Carp;

# Copyright INRA
# Jerome.Gouzy@toulouse.inra.fr

BEGIN
{
    our $VERSION = do {my @r = (q$Rev: 220 $ =~ /\d+/g); $r[0]};
}

=head2 procedure _Init

 Title        : _Init
 Function     : Constructor, initialize the object, do not use directly, use New method instead

=cut

sub _Init
{
	my ($self,%h_param) = @_;

	$self->SUPER::_Init(%h_param);
}

=head2 procedure Load

 Title        : Load
 Usage        : $o_seqds->Load;

	pour le moment, ne charge que les longueurs

=cut

sub Load 
{
	my ($self,%h_param) = @_;

	my $filein = $self->_FastOneGet('_infile');
	my $f_inf = &GetStreamIn($filein);
	my ($cpt_in,$cpt_out)=(0,0);
	my $seq=undef;
	my $id=undef;
	while (my $l = <$f_inf>)
	{	
		chomp($l);
#ref_id  ref_slen ref_sstart ref_send  ref_ntlen  ref_ntstart ref_ntend  ref_strand   tgt_id  tgt_slen  tgt_sstart  tgt_send  tgt_ntlen   tgt_ntstart  tgt_ntend  aln_len aln_score  aln_density  ref_span tgt_span
#0       1        2          3         4          5           6          7            8       9         10          11        12          13           14         15      16         17           18       19
#
#OcIN23-M4-r1c043        885     228     270     5861858 1417957 1634051 -       exp_refineFinal1_contig1000_r   58      1       40      356977  1       253936  43      12.39   0.2881  3.69    71.14
#OcIN23-M4-r1c638        63      11      63      297828  85033   289565  +       exp_refineFinal1_contig1000_r   58      15      56      356977  128772  335485  53      26.63   0.5025  68.67   57.91
		next if ( $l =~ /^ref_id/ );
		my(@a_)=split(/\t/,$l);
		$self->SetLen($a_[8],$a_[12]);
	}
	$f_inf->close;
	$self->_Set('count',$cpt);
	if ( defined($h_param{verbose}) && $h_param{verbose} )
	{
		print STDERR "Seq in: $cpt\n";
	}
	return $cpt;
}

sub SetLen
{
my($self,$key,$val) = @_;

        $self->{_rh_len}->{$key} = $val;
        return 1;
}

sub GetLen
{
my($self,$key) = @_;

        return $self->{_rh_len}->{$key};
}

sub Del
{
my($self,$key) = @_;

        delete($self->{_rh_len}->{$key});
        return 1;
}

sub PrintInfo
{
my($self) = @_;

        print  STDERR "Filename: ".$self->_FastOneGet('_infile')."\n";
        my $r_keys=$self->{'_rh_seq'};
        my $nb = keys(%$r_keys);
        if ( $nb == 0 )
        {
                $r_keys=$self->{'_rh_len'};
                $nb = keys(%$r_keys);
        }
        printf STDERR "Number of sequences loaded: %d\n",$nb;
        return $nb;
}


1;



