#!/usr/bin/perl

BEGIN
{
	$ENV{ALNPACK} = "/mnt/data15/data10/home/gouzy/alnpack-2.1/";
}
# pour simplifier, j'ai copie toutes les libraires de /mnt/data15/data10/home/gouzy/alnpack-2.1/src/lib*/.libs/* dans /mnt/data15/data10/home/gouzy/alnpack-2.1/src/lib
use Inline ( CPP => Config => INC => "-I$ENV{ALNPACK}/src/libswaligner/ -I$ENV{ALNPACK}/src/libbio/ -I$ENV{ALNPACK}/src/libutil ", LIBS => "-L$ENV{ALNPACK}/src/lib -lswaligner -lbio -lutil");

use Inline CPP;

my ($query,$query_seq,$target,$target_seq)=("Qdsfqfsdfklsqdfjlkqsdjflkqsdjflksdqjflkjqsdlkfjqsldkjf","AATGATCCATGCTGATGCATGC","Tdsfkljdqsflkqsdlkfjlksqdjflkqsdjflksdqjflkqsdj","ATGATCCATGCATGATCCATGC");

my $aln2=' ' x 500; # il faut allouer avant, je n'ai pas reussi a avoir un comportement stable lorsque je le faisais en C++ ou lorsque je ne ne fais pas
aaln($query,$query_seq,$target,$target_seq,$aln2);
$aln2=~s/\s*$//;
print "$aln2\n";

__END__
__CPP__


#include <string.h>
#include "PairwiseAlignment.h"
#include "MonardoSWAligner.h"

using namespace std;
using namespace bio;

void aaln(char *str_th,char *str_ts,char *str_bh,char *str_bs,char *strout)
{
   string th(str_th);
   string ts(str_ts);
   string bh(str_bh);
   string bs(str_bs);

   auto_ptr<SWAligner> pAligner;
   pAligner.reset(new MonardoSWAligner());

   NamedSubSequence top(th,ts);
   NamedSubSequence bot(bh,bs);

   // en principe le constructeur de top/bot aurait du s'en charger mais c'est necessaire
   top=ts;
   bot=bs;

   PairwiseAlignment aln(top,bot);
   pAligner->align(aln);
   PairwiseAlignmentStats stat = aln.getStat();
   top = aln.getTop();
   bot = aln.getBot();

   sprintf(strout,"%s %d %d %s %d %d %c %.4f %.4f %d",(const char *)top.getName().c_str(),(int)top.getFragments().front().getBeg() + 1,(int)top.getFragments().front().getEnd()
                                                     ,(const char *)bot.getName().c_str(),(int)bot.getFragments().front().getBeg() + 1,(int)bot.getFragments().front().getEnd()
													 ,(char)((top.isDirect() ^ bot.isDirect()) ? 'c' : 'd'),(float)stat.getSim(),(float)stat.getTrs(),(int)aln.getScore());
}
